package autonotaAlumno;

import java.sql.*;
import java.util.Random;
import java.util.Vector;

public class jdbcManager {

    Connection con;
    Statement st;
    ResultSet rs;

    public jdbcManager(String name, int size) throws SQLException {this();
        if (presentationExists(name.toLowerCase())) {
            dropPresentation(name.toLowerCase());
        }
        newPresentation(name.toLowerCase());
        createEntries(name.toLowerCase(), size);
    }

    public jdbcManager() {
        try {
            Class.forName("com.mysql.jdbc.Driver");
        } catch (ClassNotFoundException ex) {
            System.err.println("jdbcManager: Error al cargar los drivers");
            return;
        }
        try {
            String urlDB = "jdbc:mysql://localhost:3306/test";
            con = DriverManager.getConnection(urlDB, "", "");
        } catch (SQLException ex) {
            System.err.println("jdbcManager: Error al conectarse con el servidor");
            return;
        }
        try {
            st = con.createStatement();
        } catch (SQLException ex) {
            System.err.println("jdbcManager: Error al general la sentencia");
            return;
        }
    }

    public boolean newPresentation(String name) throws SQLException {
        if (!presentationExists(name)) {
            st.executeUpdate("CREATE TABLE " + name + " (password VARCHAR(7), status CHAR, value1 INTEGER, value2 INTEGER, value3 INTEGER, PRIMARY KEY(password))");
            return true;
        } else {
            return false;
        }
    }

    public void dropPresentation(String name) throws SQLException {
        if (presentationExists(name)) {
            st.executeUpdate("DROP TABLE " + name);
        }
    }

    public boolean presentationExists(String name) throws SQLException {
        rs = st.executeQuery("SHOW TABLES");
        while (rs.next()) {
            if (rs.getString(1).equals(name)) {
                return true;
            }
        }
        return false;
    }

    private String newPassword() {
        Random rand = new Random(System.nanoTime());
        int value;
        do value = rand.nextInt(0xfffffff); while(value < 0xffffff);
        String pass = Integer.toHexString(value);
        return pass;
    }

    public int createEntries(String name, int entries) throws SQLException {
        int i;
        for (i = 0; i < entries; i++) {
            st.executeUpdate("INSERT INTO " + name + " VALUES(\"" + newPassword() + "\",\"n\",0,0,0)");
        }
        return i;
    }

    public int getTotalPresentations() throws SQLException{
        return getPresentations().size();
    }
    
    public int getAnswered(String name) throws SQLException{
        return getValues(name).size();
    }
    
    public boolean isAswered(String name, String pass) throws SQLException{
        rs = st.executeQuery("SELECT status FROM " + name + " WHERE password = \"" + pass + "\"");
        rs.next();
        if(rs.getString("status").equals("y")) return true;
        else return false;
    }

    public boolean setValues(String name, String password, int value1, int value2, int value3) throws SQLException {
        if (entryExist(name, password)) {
            st.executeUpdate("UPDATE " + name +
                    " SET status = \"y\", " +
                    "value1 = " + value1 + ", " +
                    "value2 = " + value2 + ", " +
                    "value3 = " + value3 + " " +
                    "WHERE password = \"" + password + "\"");
            return true;
        } else {
            return false;
        }
    }

    public boolean entryExist(String name, String password) throws SQLException {
        rs = st.executeQuery("SELECT * FROM " + name);
        while (rs.next()) {
            if (rs.getString("password").equals(password)) {
                return true;
            }
        }
        return false;
    }

    public Vector<String> getPasswords(String name) throws SQLException {
        Vector<String> passwords = new Vector<String>();
        rs = st.executeQuery("SELECT password FROM " + name);
        while (rs.next()) {
            passwords.addElement(rs.getString(1));
        }

        return passwords;
    }
    
    public Vector<values> getValues(String name) throws SQLException {
        Vector<values> values = new Vector<values>();
        int value1,value2,value3;
        rs = st.executeQuery("SELECT * FROM " + name + " WHERE status = \"y\"");
        while(rs.next()){
            value1 = rs.getInt("value1");
            value2 = rs.getInt("value2");
            value3 = rs.getByte("value3");
            values.addElement(new values(value1,value2,value3));
        }
        return values;
    }
    
    public Vector<String> getPresentations() throws SQLException{
        Vector<String> tables = new Vector<String>();
        rs = st.executeQuery("SHOW TABLES");
        while (rs.next()) {
            tables.addElement(rs.getString(1));
        }

        return tables;
    }
}
